; Programa: Package con agente jugador simple de Tron,
;           juego tambin denominado "light cycle",
;           ver http://en.wikipedia.org/wiki/Light_cycle
;
; Asignatura: Introduccin a la Inteligencia Artificial
;             ETSII - ULL
; Prctica: (sistemas de produccin)
; Autor:    aluXXXX
; Fecha:    03/05/2006
; Comentarios:
;
;           Este cdigo supone un esqueleto de ejemplo de el
;           fichero que ha de contener los agentes jugadores
;           de tron que el usuario defina. Inicialmente dispone
;           de un nico agente (equivalente al agente-simple-mitad).
;
;           Para personalizar este fichero ha de renombrarse,
;           sustituyendo "aluXXXX" por el lo que desee. Adems
;           en este cdigo ha de reemplazarse dondequiera que
;           apareza "aluXXXX" o "ALUXXXX" por lo mismo, ya que
;           el nombre del fichero sin extensin y el nombre
;           del package aqu incluido han de coincidir (no
;           sensitivo a maysculas").
;
;           Para aadir ms agentes habrn de generarse las
;           funciones correspondientes para los agentes, exportarlas
;           dentro de la seccin ":export" de defpackage, e 
;           incluirlas como sublistas en el contenido de la
;           constante (defconstant) agentes. Para ms informacin
;           consultar "tron-agentes-simples.lsp" y 
;           "tron-loader.lsp".
;
;           Los agentes definidos utilizan el entorno de juego
;           Tron, definido principalmente por los packages
;           tron-base y tron-comm.
;
;           Las funciones accesibles ms importantes son:
;
;             agente-aluXXXX-mitad
;
;           Ver la documentacin existente para cada una de ellas.
;
;           Para su utilizacin es aconsejable usar el cargador
;           del entorno de juego tron: tron-loader.lsp.
;
;
; Dependencias:
;
;           Hace uso del paquete que contiene la interface (tron-comm)
;           con el control del juego (tron-base).
;
;
; Modificaciones:
;
;           - Ver 0.1 (03/05/2006): Primera versin. Extraida
;             de tron-agentes-simples.lsp.
;
;           - Ver 0.1.1 (03/05/2006): Documentado y subsanado error
;             en nombre de variable *version-agentes-aluXXXX*.
;

; Por hacer:
;
;
;


;
; Definicin del package
; ----------------------

(defpackage "AGENTES-ALUXXXX"
  (:use "LISP" "TRON-COMM")
  (:export "AGENTES" "*VERSION-AGENTES-ALUXXXX*" "AGENTE-ALUXXXX-MITAD"))


(in-package "AGENTES-ALUXXXX")


;
; Constante con lista de agentes presentes en este package
; --------------------------------------------------------

(defconstant agentes
  '((agente-aluXXXX-mitad))
  "Agentes simples para jugar a TRON de aluXXXX.")


;
; Constante versin
; -----------------

(defconstant *version-agentes-aluXXXX* "0.1.1"
  "Versin del package agentes-aluXXXXs.")


;
; Funciones de tratamiento de lista de direcciones preferentes
; ------------------------------------------------------------

(defun dir-vacia-p (pos dir)
  "Mira en la posicin POS si movndose en la direccin DIR est vaca, devolviendo DIR en tal caso y NIL en caso contrario."
  (if (null (consulta-pos-tab pos dir))
      dir))

(defun dir-inc (dir dir-ini)
  "Calcula la direccin DIR relativa a DIR-INI, esto es, gira DIR-INI pasos en sentido agujas del reloj sobre DIR."
  (rem (+ dir dir-ini) 4))

(defun dir-vacia-pref (pos lis-dir-pref &optional (dir-ini 0))
  "Busca la primera direccin vaca alrededor de POS siguiendo el orden de LIS-DIR-PREF, si DIR-INI est instanciado las direcciones de LIS-DIR-PREF son relativas a DIR-INI."
  (if (consp lis-dir-pref)
      (or (dir-vacia-p pos (dir-inc (first lis-dir-pref) dir-ini))
	  (dir-vacia-pref pos (rest lis-dir-pref) dir-ini))))


;
; Agente NSEO
; -----------

(defun agente-aluXXXX-mitad (id)
  "Agente jugador Tron que slo busca la mitad."
  (dir-vacia-pref (consulta-pos-jug id) '(0 2 1 3)))

